<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Bootstrap Flex</title>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<h1 class ="text-center my-5">Bootstrap Flex</h1>
	<!-- 

     Flexbox is used to manipulate and layout our elements. This can be done exclusively in CSS. However, using bootstrap it is much easier and faster to implement flex because all we have to do is add the class d-flex to the parent of our flex items.

     Flex items, Flex Children, when adding d-flex to their parent, the items are in a row. We can adjust their height and width not like your inline elements.

     items in a row. We can adjsut their height and width not like your inline elements:

     Flex Directions:

     You can change the direction of your flex items by adding flex-direction, however, by default, flex row is the arrangement of our flex items.


     Flex Column 
     Flex column will arrange our items top to bottom and by default the flex item will occupy the width or its parents


     Flex Column Reverse 
     Does the same as flex-column
     

	 -->
	 <h3 class="text-center my-3">Flex Row</h3>
    <div class="bg-dark d-flex flex-row mb-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row mb-4">
    	<span class="bg-primary p-2">Span Flex 1</span>
    	<span class="bg-danger p-2">Span Flex 2</span>
    	<span class="bg-success p-2">Span Flex 3</span>	
    </div>
      <h3 class="text-center my-5">Flex Row Reverse</h3>
      <div class="bg-dark d-flex flex-row-reverse mb-4">
    	<div class= "bg-primary p-2">Span Flex 1</div>
    	<div class="bg-danger p-2">Span Flex 2</div>
    	<div class="bg-success p-2">Span Flex 3</div>	
    </div>
    <h3 class="text-center my-5"></h3>
    <div class="d-flex flex-column bg-dark mb-4 p-4">Flex Item 1
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div> <div class="d-flex flex-column bg-dark mb-4 p-4">Flex Item 1
    	<span class="bg-primary p-2">Flex Item 1</span>
    	<span class="bg-danger p-2">Flex Item 2</span>+
    	<span class="bg-success p-2">Flex Item 3</span>
    </div>
    <h3 class="my-5 text-center">Flex Column Reverse</h3>
    <div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div> 
    <h3 class="my-5 text-center">Flex row Reverse</h3>
    <div class="bg-dark d-flex flex-row-reverse mb-4 p-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>

    <!-- Justify Content -->
    <h2 class="text-center my-5">Justify Content</h2>
    <!-- jsutify content allows us to manipulate and change the alignment of our flex items along our main axis. The main axis for flex-row item is our x-axis justify content allows us to horizontally aligh our flex-row items -->
    <h3 class="text-center my-5">Justify Content Start</h3>
    <!-- justify-content-start is the default value of justify-content for flex items. allows us to align our flex items to the start of their main axis.For flex-row it starts form the left, for flex-row-reverse it starts from the right -->
    <div class="bg-dark d-flex flex-row justify-content-start bg-dark mb-4">	
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>
 <div class="bg-dark d-flex flex-row-reverse justify-content-start bg-dark mb-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>
    <!--  -->
    <h3 class="text-center my-5">Justify Content End</h3>
    <!-- Aligns our flex items where our main axis ends. For flex-row, the end from the right, for flex-row	 -->
    <div class="bg-dark d-flex flex-row justify-content-end mb-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>
 <div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>
    <h3 class="text-center my-5"></h3>
    <div class="bg-dark d-flex flex-row justify-content-center mb-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>    <div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    </div>
    <h3 class="text-center my-5">Justify Content Between</h3>
    <div class="d-flex flex-row justify-content-between bg-dark mb-4">
        <div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>
<div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
        <div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>
    <h3 class="text-center my-5">Justify Content Around</h3>
    <div class="bg-dark d-flex flex-row justify-content-around bg-dark mb-4">
    	 <div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>

  <div class="bg-dark d-flex flex-row-reverse justify-content-around bg-dark mb-4">
    	 <div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>
    <!-- Align Items -->
    <h2 class="text-center">Align Items</h2>
    <div class="d-flex flex-row align-items-start bg-dark mb-4"style="height:50vh;">
    	 <div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>
<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4"style="height
:50vh;">
    	 <div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
 </div>
 <h3 class="text-center my-5">Align Items End</h3>
 <div class="d-flex flex-row align-items-end bg-dark mb-4" style="height:50vh">
 	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
 </div>
     <div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height:50vh">
 	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
 </div>
 <h3 class="text-center my-5">Align Items Center</h3>
 <div class="d-flex flex-row mb-4 bg-dark align-items-center" style="height:50vh;">
 	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
 </div>
 <div class="d-flex flex-row-reverse mb-4 bg-dark align-items-center" style="height:50vh;">
 	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
 </div>

 <h2>Aligning items horizontally and vertically</h2>
    <div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:50vh;">
    		<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>
   <div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:50vh;">
    		<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>  
    <div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
    		<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
    </div>

    <!-- 
       Mini-Activity

       Add an h3 with the text Mini-Activity with Flex Row

       -center the text 
       -add a bootstrap size 5 margin on the top and bottom of the h3

       Add a div as a flex parent:
          Add classes to arrange/align our items:
           -arrange items in a row 
           -center the items both horizontally and vertically 
           - You can copy the div flex items from oour other examples
           - add dark bg to the flex
           -parents has 50vh height 

        Add a div as a flex parent :
        add classes to arrange/align our items:
        -arrange the items in a row 
        -center the items vertically
        -align the items horizontally by evenly distributing space between the items.
        -you can copy the div flex items

     -->
     <h3 class="text-center my-5">Mimi Activity with Flex Row</h3>
     <div class="bg-dark d-flex flex-row justify-content-center align-items-center mb-4"style="height:50vh;">
     	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
     </div>
     <div class="bg-dark flex-row d-flex align-items-center justify-content-between"style="height: 50vh;">
     	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-info p-2">Flex Item 4</div>
    	<div class="bg-warning p-2">Flex Item 5</div>
     </div>

     <h2>Flex Column with Align Items and Justfiy Contents</h2>
     <div class="d-flex flex-column align-items-center bg-dark mb-4" style="height: 50vh;">
     	<div class="bg-primary p-2"style="width: 20%;">Flex Item 1</div>
    	<div class="bg-danger p-2"style="width: 20%;">Flex Item 2</div>
    	<div class="bg-success p-2"style="width: 20%;">Flex Item 3</div>
     </div> 
     <div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height: 50vh;">
     	<div class="bg-primary p-2"style="width: 20%;">Flex Item 1</div>
    	<div class="bg-danger p-2"style="width: 20%;">Flex Item 2</div>
    	<div class="bg-success p-2"style="width: 20%;">Flex Item 3</div>
     </div>

         <h3 class="text-center my-5">Mini Activity with Flex Column</h3>
     <!-- For the first parent width arrange each children with flex:

           flex items must be arranged in a column 
           align the flex items at the bottom of the parent 

          For the second parent arange each children with flex:

             flex items must be arranged in a column 
             align the flex items to the right of the parent 
          Both parents should have dark background and mb-4

      -->
       <div class="bg-dark mb-4 d-flex flex-column justify-content-end" style="height: 50vh;">
     	<div class="bg-primary p-2"style="width: 20%;">Flex Item 1</div>
    	<div class="bg-danger p-2"style="width: 20%;">Flex Item 2</div>
    	<div class="bg-success p-2"style="width: 20%;">Flex Item 3</div>
     </div>

     <div class="bg-dark mb-4 d-flex flex-column align-items-end" style="height: 50vh;">
     	<div class="bg-primary p-2"style="width: 20%;">Flex Item 1</div>
    	<div class="bg-danger p-2"style="width: 20%;">Flex Item 2</div>
    	<div class="bg-success p-2"style="width: 20%;">Flex Item 3</div>
     </div>
       <h3 class="text-center my-5">Flex Column with Justify Content Between and Around</h3>
      <div class="bg-dark mb-4 d-flex flex-column justify-content-between" style="height: 50vh;">
     	<div class="bg-primary p-2"style="width: 20%;">Flex Item 1</div>
    	<div class="bg-danger p-2"style="width: 20%;">Flex Item 2</div>
    	<div class="bg-success p-2"style="width: 20%;">Flex Item 3</div>
     </div>

     <div class="bg-dark mb-4 d-flex flex-column justify-content-around" style="height: 50vh;">
     	<div class="bg-primary p-2"style="width: 20%;">Flex Item 1</div>
    	<div class="bg-danger p-2"style="width: 20%;">Flex Item 2</div>
    	<div class="bg-success p-2"style="width: 20%;">Flex Item 3</div>
     </div>
    
     <h3 class="text-center my-5">Flex Wrap</h3>
     <div class="bg-dark d-flex flex-row mb-4 justify-content-around flex-wrap">
     	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-success p-2">Flex Item 3</div>
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
        <div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
    	<div class="bg-primary p-2">Flex Item 1</div>
    	<div class="bg-danger p-2">Flex Item 2</div>
     </div>
     








<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>